/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: DefaultEjbJarDeployableFactory.java 4610 2009-02-17 08:49:37Z gaellalire $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.ee.metadata.ejbjar.impl.internal;

import org.ow2.util.ee.deploy.api.deployable.EJBDeployable;
import org.ow2.util.ee.metadata.ejbjar.impl.EjbJarDeployableMetadataFactory;
import org.ow2.util.ee.metadata.ejbjar.impl.configurator.EjbJarDeployableMetadataConfigurator;
import org.ow2.util.scan.api.IScanner;

/**
 * Simple class for getting metadata of EJBs.
 * @param <E> an implementation of EJBDeployable
 * @author Florent Benoit
 */
public class DefaultEjbJarDeployableFactory<E extends EJBDeployable<E>>
        extends
        EjbJarDeployableMetadataFactory<E, DefaultEjbJarDeployableMetadata<E>, DefaultEjbJarClassMetadata<E>, DefaultEjbJarMethodMetadata<E>, DefaultEjbJarFieldMetadata<E>> {

    public DefaultEjbJarDeployableFactory() {
    }

    public DefaultEjbJarDeployableFactory(final IScanner scanner) {
        super(scanner);
    }

    @Override
    protected DefaultEjbJarDeployableMetadata<E> createEjbJaDeployableMetadata(final E ejbDeployable) {
        return new DefaultEjbJarDeployableMetadata<E>(ejbDeployable);
    }

    @Override
    protected EjbJarDeployableMetadataConfigurator<E, DefaultEjbJarDeployableMetadata<E>, DefaultEjbJarClassMetadata<E>, DefaultEjbJarMethodMetadata<E>, DefaultEjbJarFieldMetadata<E>> createEjbJarDeployableMetadataConfigurator(
            final E ejbDeployable) {
        return new DefaultEjbJarDeployableMetadataConfigurator<E>(new DefaultEjbJarDeployableMetadata<E>(ejbDeployable));
    }

}
